unit UMainFrm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, uADStanIntf, uADStanOption,
  uADStanError, uADGUIxIntf, uADPhysIntf, uADStanDef, uADStanPool, uADStanAsync,
  uADPhysManager, uADStanParam, uADDatSManager, uADDAptIntf, uADDAptManager,
  uADGUIxFormsWait, uADCompGUIx, uADPhysIB, Data.DB, uADCompClient,
  uADCompDataSet, Vcl.ExtCtrls, Vcl.DBCtrls, Vcl.Grids, Vcl.DBGrids,
  Vcl.StdCtrls, Vcl.ComCtrls, Vcl.Imaging.pngimage, Vcl.Buttons;

type
  TMainFrm = class(TForm)
    ADConnection1: TADConnection;
    qMaster: TADQuery;
    uqMaster: TADUpdateSQL;
    dsoMaster: TDataSource;
    gMaster: TDBGrid;
    nMaster: TDBNavigator;
    ADPhysIBDriverLink1: TADPhysIBDriverLink;
    ADGUIxWaitCursor1: TADGUIxWaitCursor;
    Label1: TLabel;
    Label2: TLabel;
    gDetail: TDBGrid;
    nDetail: TDBNavigator;
    qDetail: TADQuery;
    uqDetail: TADUpdateSQL;
    dsoDetail: TDataSource;
    ADTransaction1: TADTransaction;
    Label3: TLabel;
    bPrimary: TButton;
    StatusBar1: TStatusBar;
    bDeadLock: TButton;
    bUniqueKey: TButton;
    bRequiredField: TButton;
    bForeingKey: TButton;
    bValidation: TButton;
    Image1: TImage;
    Image2: TImage;
    bConstraintCheck: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bPrimaryClick(Sender: TObject);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
    procedure StatusBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StatusBar1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bDeadLockClick(Sender: TObject);
    procedure bUniqueKeyClick(Sender: TObject);
    procedure bRequiredFieldClick(Sender: TObject);
    procedure bForeingKeyClick(Sender: TObject);
    procedure bValidationClick(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure bConstraintCheckClick(Sender: TObject);
  private
    function OpenDataSet(DataSet: TDataSet): Boolean;
  public
    constructor Create(AOwner: TComponent); override;
  end;

var
  MainFrm: TMainFrm;

implementation

uses
  Winapi.ShellAPI, System.Types,
  uADPhysIBWrapper, FBErrorsFireDAC;

{$R *.dfm}

function GetStatusBarPanelXY(StatusBar : TStatusBar; X, Y: Integer) : Integer;
var
  i: Integer;
  R: TRect;
begin
  Result := -1;

  // Buscamos panel a panel hasta encontrar en cual est XY
  with StatusBar do
    for i := 0 to Panels.Count - 1 do
    begin
      // Obtenemos las dimensiones del panel
      SendMessage(Handle, WM_USER + 10, i, Integer(@R));
      if PtInRect(R, Point(x,y)) then
      begin
        Result := i;
        Break;
      end;
    end;
end;

procedure TMainFrm.bConstraintCheckClick(Sender: TObject);
begin
  qDetail.Append;
  qDetail.FieldByName('id').AsInteger := 22;
  qDetail.FieldByName('master_id').AsInteger := 2;
  qDetail.FieldByName('activated').AsInteger := 4;
  try
    qDetail.Post;
  except
    on E: Exception do
    begin
      ShowMessage(TFBErrorsFireDAC.GetFBMessageError(E, ADConnection1));
      qDetail.Cancel;
    end;
  end;
end;

procedure TMainFrm.bDeadLockClick(Sender: TObject);
begin
  ADTransaction1.Options.AutoCommit := False;
  ADTransaction1.Options.AutoStop := False;
  qMaster.First;
  qMaster.Edit;
  qMaster.FieldByName('description').AsString := '';
  try
    qMaster.Post;
  except
    on E: Exception do
    begin
      ShowMessage(TFBErrorsFireDAC.GetFBMessageError(E, ADConnection1));
      qMaster.Cancel;
    end;
  end;
  ADTransaction1.Options.AutoCommit := True;
  ADTransaction1.Options.AutoStop := True;
end;

procedure TMainFrm.bForeingKeyClick(Sender: TObject);
begin
  qDetail.Append;
  qDetail.FieldByName('id').AsInteger := 22;
  qDetail.FieldByName('master_id').AsInteger := 22;
  try
    qDetail.Post;
  except
    on E: Exception do
    begin
      ShowMessage(TFBErrorsFireDAC.GetFBMessageError(E, ADConnection1));
      qDetail.Cancel;
    end;
  end;
end;

procedure TMainFrm.bPrimaryClick(Sender: TObject);
begin
  qMaster.Append;
  qMaster.FieldByName('id').AsInteger := 1;
  try
    qMaster.Post;
  except
    on E: Exception do
    begin
      ShowMessage(TFBErrorsFireDAC.GetFBMessageError(E, ADConnection1));
      qMaster.Cancel;
    end;
  end;
end;

procedure TMainFrm.bRequiredFieldClick(Sender: TObject);
begin
  qMaster.Append;
  try
    qMaster.Post;
  except
    on E: Exception do
    begin
      ShowMessage(TFBErrorsFireDAC.GetFBMessageError(E, ADConnection1));
      qMaster.Cancel;
    end;
  end;
end;

procedure TMainFrm.bUniqueKeyClick(Sender: TObject);
begin
  qMaster.First;
  qMaster.Edit;
  qMaster.FieldByName('reference').AsString := '22';
  try
    qMaster.Post;
  except
    on E: Exception do
    begin
      ShowMessage(TFBErrorsFireDAC.GetFBMessageError(E, ADConnection1));
      qMaster.Cancel;
    end;
  end;
end;

procedure TMainFrm.bValidationClick(Sender: TObject);
begin
  qMaster.First;
  qMaster.Append;
  qMaster.FieldByName('id').AsInteger := 4;
  try
    qMaster.Post;
  except
    on E: Exception do
    begin
      ShowMessage(TFBErrorsFireDAC.GetFBMessageError(E, ADConnection1));
      qMaster.Cancel;
    end;
  end;
end;

constructor TMainFrm.Create(AOwner: TComponent);
begin
  inherited;

  if ADConnection1.Connected then ADConnection1.Close;
  ADConnection1.Params.Clear;
  ADConnection1.Params.Add('User_Name=sysdba');
  ADConnection1.Params.Add('Password=masterkey');
  ADConnection1.Params.Add('CharacterSet=UTF8');
  ADConnection1.Params.Add('DriverID=FB25_SERVER');
  ADConnection1.Params.Add('Database=' + ExtractFilePath(ParamStr(0)) + 'TESTDB.FDB');
  ADConnection1.Params.Add('PageSize=16384');
  try
    ADConnection1.Open;
  except
    on E: Exception do
    begin
      ShowMessage(TFBErrorsFireDAC.GetFBMessageError(E, ADConnection1));
      Exit;
    end;
  end;
  if not OpenDataSet(qMaster) then Exit;
  if not OpenDataSet(qDetail) then Exit;
end;

procedure TMainFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ADConnection1.InTransaction then
    ADConnection1.Rollback;
end;

procedure TMainFrm.Image1Click(Sender: TObject);
begin
  Application.MessageBox('FireDAC no controla esta excepcin, por lo que el tipo de error devuelto no es EIBNativeException sino EDatabaseError, por lo que no se puede gestionar correctamente.'#13#13'Y eso que tienen la constante isc_not_valid definida!!', 'Informacin', MB_APPLMODAL or MB_ICONINFORMATION or MB_OK);
end;

procedure TMainFrm.Image2Click(Sender: TObject);
begin
  Application.MessageBox('Para probocar un deadlock tienes que abrir una nueva instancia del programa y pulsar el botn "deadlock" en ambas. En la ltima aplicacin en que lo pulses, se producir el deadlock.', 'Informacin', MB_APPLMODAL or MB_ICONINFORMATION or MB_OK);
end;

function TMainFrm.OpenDataSet(DataSet: TDataSet): Boolean;
begin
  Result := True;
  try
    DataSet.Open;
  except
    on E: Exception do
    begin
      ShowMessage(TFBErrorsFireDAC.GetFBMessageError(E, ADConnection1));
      Result := False;
    end;
  end;
end;

procedure TMainFrm.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
  StatusBar.Canvas.Font.Color := clBlue;
  Statusbar.Canvas.TextRect(Rect, Rect.Left, Rect.Top, Panel.Text);
end;

procedure TMainFrm.StatusBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if GetStatusBarPanelXY(StatusBar1, X, Y) = 1 then
    StatusBar1.Cursor := crHandPoint
  else
    StatusBar1.Cursor := crDefault;
end;

procedure TMainFrm.StatusBar1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (GetStatusBarPanelXY(StatusBar1, X, Y) = 1) and (Button = mbLeft) then
    ShellExecute(Handle, 'open', 'http://www.cadetill.com', nil, nil, SW_SHOW);
end;

end.
